import { getNotificationContainer } from '../notification-util';
/**
 * Shows the notificationStructure
 * @internal
 * @param notificationStructure - The NotificationStructure object
 * @param tagName - The tag name to create prefix for the design system provider & notificationStructure component
 * @returns
 * */
export const showToast = (notificationStructure, tagName) => {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
    const tagPrefix = tagName.split('-')[0];
    const container = getNotificationContainer('notify-container', tagName);
    if (container) {
        container.style.position = 'fixed';
        switch ((_b = (_a = notificationStructure === null || notificationStructure === void 0 ? void 0 : notificationStructure.config) === null || _a === void 0 ? void 0 : _a.toast) === null || _b === void 0 ? void 0 : _b.position) {
            case 'top-left':
                container.style.top = '0';
                container.style.left = '0';
                break;
            case 'bottom-left':
                container.style.bottom = '0';
                container.style.left = '0';
                break;
            case 'bottom-right':
                container.style.bottom = '0';
                container.style.right = '0';
                break;
            default:
                container.style.top = '0';
                container.style.right = '0';
        }
    }
    const toastNotify = document.createElement(`${tagPrefix}-toast`);
    const toastTitle = document.createElement('div');
    toastTitle.setAttribute('slot', 'top');
    toastTitle.textContent = notificationStructure.title;
    const toastDetails = document.createElement('div');
    toastDetails.setAttribute('slot', 'content');
    toastDetails.textContent = (notificationStructure === null || notificationStructure === void 0 ? void 0 : notificationStructure.body) || '';
    const toastDate = document.createElement('div');
    toastDate.setAttribute('slot', 'date');
    toastDate.textContent = new Date().toLocaleTimeString();
    toastNotify.setAttribute('notify', ((_d = (_c = notificationStructure === null || notificationStructure === void 0 ? void 0 : notificationStructure.config) === null || _c === void 0 ? void 0 : _c.toast) === null || _d === void 0 ? void 0 : _d.type) || '');
    ((_f = (_e = notificationStructure === null || notificationStructure === void 0 ? void 0 : notificationStructure.config) === null || _e === void 0 ? void 0 : _e.toast) === null || _f === void 0 ? void 0 : _f.autoClose)
        ? toastNotify.setAttribute('auto-close', `${(_h = (_g = notificationStructure === null || notificationStructure === void 0 ? void 0 : notificationStructure.config) === null || _g === void 0 ? void 0 : _g.toast) === null || _h === void 0 ? void 0 : _h.autoClose}`)
        : '';
    ((_k = (_j = notificationStructure === null || notificationStructure === void 0 ? void 0 : notificationStructure.config) === null || _j === void 0 ? void 0 : _j.toast) === null || _k === void 0 ? void 0 : _k.closeTimeout)
        ? toastNotify.setAttribute('close-timeout', `${(_m = (_l = notificationStructure === null || notificationStructure === void 0 ? void 0 : notificationStructure.config) === null || _l === void 0 ? void 0 : _l.toast) === null || _m === void 0 ? void 0 : _m.closeTimeout}`)
        : '';
    toastNotify.appendChild(toastTitle);
    toastNotify.appendChild(toastDetails);
    toastNotify.appendChild(toastDate);
    container.appendChild(toastNotify);
};
